#!/usr/bin/perl
# Knihovn funkce parseru potebn jak pi trninku, tak pi analze.



# Pest konfiguran soubor.
open(SOUBOR, "parser.ini");
while(<SOUBOR>)
{
    # Smazat z konfiguranho souboru komente.
    s/#.*//;
    # Zbytek m tvar "promnn = hodnota".
    if(m/(\w+)\s*=\s*(.*)/)
    {
        $konfig{$1} = $2;
    }
}
close(SOUBOR);



#------------------------------------------------------------------------------
# Nate slovo ze vstupu.
#------------------------------------------------------------------------------
sub zpracovat_slovo
{
    $mzdroj = "MD"; # MD, MM nebo nic
    $ord++;
    #==========================================================================
    # Pest slovn tvar.
    #==========================================================================
    m/<[fd]( [^>]*)?>([^<]+)/;
    $slova[$ord] = $2;
    $slova[$ord] =~ tr/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/;
    #==========================================================================
    # Pest heslov tvar.
    #==========================================================================
    m/<$konfig{mzdroj0}l[^>]*>([^<]+)/;
    $hesla[$ord] = $1;
    $hesla[$ord] =~ s/_(.*)$//;
    my $lexkat = $1;
    #==========================================================================
    # Pest morfologickou znaku.
    #==========================================================================
    if($konfig{mzdroj0} eq "MM")
    {
        # Znaek me bt vce, nast vechny.
        $mznacky[$ord] = "";
        while(s/<MMt[^>]*>(...............)//)
        {
            $mznacky[$ord] .= "|$1";
        }
        $mznacky[$ord] =~ s/^\|//;
        my @mmznacky = split(/\|/, $mznacky[$ord]);
        my @mmredzn;
        # Redukovat znaky.
        for(my $i = 0; $i<=$#mmznacky; $i++)
        {
            $mmznacky[$i] =~ m/^(.)(.)..(.)/;
            $mmredzn[$i] = $3=="-" ? $1.$2 : $1.$3;
        }
        @mmredzn = sort(@mmredzn);
        $znacky[$ord] = join("|", @mmredzn);
        while($znacky[$ord] =~ s/(..)\|\1/$1/g) {}
    }
    else
    {
        m/<$konfig{mzdroj0}t.*?(?:src="$konfig{mzdroj1}")?.*?>([^<]+)/;
        $mznacky[$ord] = $1;
    }
    #==========================================================================
    # Upravit morfologickou znaku.
    #==========================================================================
    my @mznacky_ord = split(/\|/, $mznacky[$ord]);
    for(my $i = 0; $i<=$#mznacky_ord; $i++)
    {
        $mznacky_ord[$i] = upravit_mznacku($mznacky_ord[$i],
        $lexkat, $hesla[$ord], $slova[$ord]);
    }
    $znacky[$ord] = join("|", @mznacky_ord);
    #==========================================================================
    # Zjistit syntaktickou strukturu a syntaktickou znaku.
    #==========================================================================
    m/<g>(\d+)/;
    $struktura[$ord] = $1;
    m/<A>([^<]+)/;
    $afun[$ord] = $1;
    if($afun[$ord]=~m/$konfig{"vynech"}/)
    {
        $vynechat_vetu = 1;
    }
}



#------------------------------------------------------------------------------
# Vymae vechny globln promnn popisujc vtu, kter vznikly v procedue
# zpracovat_slovo. Typicky se vol na konci procedury zpracovat_vetu, aby bylo
# mon natat dal vtu.
#------------------------------------------------------------------------------
sub vymazat_vetu
{
    # Informace o slovech.
    splice(@slova, 1); # Dvojk v koeni ponechat.
    splice(@hesla, 1);
    splice(@mznacky, 1);
    splice(@znacky,1);
    $ord = 0;
    # Informace o vztazch.
    splice(@struktura);
    splice(@afun);
    # Informace o vt.
    $sloveso = 0; # Zda vta obsahuje sloveso.
    $vynechat_vetu = 0;
    # Statistiky udlost.
    splice(@uduss);
    splice(@udkjj);
    splice(@udoss);
    splice(@udozz);
    splice(@udkzz);
}



#------------------------------------------------------------------------------
# Uprav morfologickou znaku. Vol se pi ten znaky, tedy z funkce
# zpracovat_slovo(). Zapisuje do globln promnn $sloveso. Kontrolu vskytu
# slovesa je dobr dlat tady, protoe jedno slovo me mt vce znaek a jen
# nkter z nich mohou bt slovesn.
#------------------------------------------------------------------------------
sub upravit_mznacku()
{
    my $znacka = $_[0];
    my $lznacka = $_[1]; # stylistick a vznamov kategorie
    my $heslo = $_[2];
    my $slovo = $_[3];
    #==========================================================================
    # Kontrola vskytu slovesa (kvli zvislostem na koeni).
    if($znacka =~ m/^V/)
    {
        $sloveso = 1;
    } 
    #==========================================================================
    $znacka =~ m/^(.)(.)..(.)/;
    $znacka = $3=="-" ? $1.$2 : $1.$3;
    # Machinace se znakami.
    if($znacka=~m/^N/ && $lznacka=~m/Y/)
    {
	$znacka =~ s/^N/NY/;
    }
    # Lexikalizace znaek pro interpunkci.
    elsif($znacka eq "Z:")
    {
	$znacka = "Z".$slovo;
    }
    # Selektivn lexikalizace znaek.
    if($konfig{"selex"})
    {
	if($znacka=~m/^P/ && $slovo=~m/(se|si)/)
	{
	    $znacka = "P".$slovo;
	}
	elsif($znacka=~m/^V/)
	{
	    if($heslo eq "bt")
	    {
		my $byt = $slovo;
		$byt =~ s/^ne//;
		$byt =~ s/ti$/t/;
		$byt =~ s/byl[aoiy]/byl/;
		$znacka = "V".$byt;
	    }
	}
	elsif($znacka=~m/^R/)
	{
	    $znacka = "R".$heslo;
	}
	elsif($znacka=~m/^J/ && $slovo=~m/(e|aby|zda)/)
	{
	    $znacka = "J".$slovo;
	    $znacka =~ s/zdali/zda/;
	}
    }
    return $znacka;
}



#------------------------------------------------------------------------------
# Zjist doplkov parametry zvislosti.
# te globln promnn @slova a $sloveso.
#------------------------------------------------------------------------------
sub zjistit_smer_a_delku
{
    my $r = $_[0];
    my $z = $_[1];
    my $smer;
    my $delka;
    my($j0, $j1, $j);
    if($r==0)
    {
	# U koene ns nezajm smr, ale zajm ns existence slovesa.
	$smer = $sloveso ? "V" : "N";
    }
    else
    {
	# Zjistit smr zvislosti (doprava nebo doleva).
	$smer = $r<$z ? "P" : "L";
    }
    # Zjistit dlku zvislosti (daleko nebo blzko (v sousedstv)).
    $delka = abs($r-$z)>1 ? "D" : "B";
    # Rozit dlku o informaci, zda se mezi $r a $z nachz rka.
    if($delka eq "D")
    {
	if($smer eq "L")
	{
	    $j0 = $z+1;
	    $j1 = $r-1;
	}
	else
	{
	    $j0 = $r+1;
	    $j1 = $z-1;
	}
	for($j = $j0; $j<=$j1; $j++)
	{
	    if($slova[$j] eq ",")
	    {
		$delka = ",";
		last;
	    }
	}
    }
    return $smer, $delka;
}



#------------------------------------------------------------------------------
# Pevede koordinace do tvaru vhodnjho pro parsing (koenem je posledn
# len koordinace).
#------------------------------------------------------------------------------
sub transformovat_koordinace
{
    return if(!$konfig{"transkoord"});
    # Prochzet seznam uzl odzadu. Hledat posledn len koordinace.
    my $i;
    my $j;
    for($i = $#struktura; $i>=0; $i--)
    {
        if($afun[$struktura[$i]] =~ m/^Coord/ &&
           $afun[$i] =~ m/_Co$/)
        {
            my $spojka = $struktura[$i];
            $struktura[$i] = $struktura[$spojka];
            $struktura[$spojka] = $i;
            # Prvn zpsob transformace. Koordinan spojka a posledn len se
            # vymn, ostatn zstanou (tj. vis nyn na poslednm lenu).
            if($konfig{"transkoord"}==1)
            {
                # Najt vechny jej dal leny koordinace a povsit je
                # do etzku pod poslednho lena. Obdobn spojku a rky.
                for($j = $i-1; $j>=0; $j--)
                {
                    if($struktura[$j]==$spojka)
                    {
                        $struktura[$j] = $i;
                    }
                }
            }
            # Druh zpsob transformace. Koenem je posledn len, na nm
            # vis spojka a pedposledn len. Kad dal len pak vis na
            # lenu napravo od nj i se spojkou, kter je oddluje.
            elsif($konfig{"transkoord"}==2)
            {
                my $pravy_soused = $i;
                for($j = $i-1; $j>=0; $j--)
                {
                    if($struktura[$j]==$spojka)
                    {
                        if($afun[$j] =~ m/_Co$/)
                        {
                            $struktura[$j] = $pravy_soused;
                            $pravy_soused = $j;
                        }
                        elsif($afun[$j] eq "AuxX")
                        {
                            $struktura[$j] = $pravy_soused;
                        }
                        else
                        {
                            $struktura[$j] = $i;
                        }
                    }
                }
            }
            else
            {
                my $pravy_soused = $spojka;
                for($j = $i-1; $j>=0; $j--)
                {
                    if($struktura[$j]==$spojka)
                    {
                        if($afun[$j] =~ m/_Co$/ ||
                           $afun[$j] eq "AuxX")
                        {
                            $struktura[$j] = $pravy_soused;
                            $pravy_soused = $j;
                        }
                        else
                        {
                            $struktura[$j] = $i;
                        }
                    }
                }
            }
            # Jet projt uzly, kter nejsou leny koordinace, ale jsou na n
            # zvisl, a le napravo od poslednho lenu koordinace.
            for($j = $i+1; $j<=$#struktura; $j++)
            {
                if($struktura[$j]==$spojka)
                {
                    $struktura[$j] = $i;
                }
            }
            $afun[$spojka] = "zpracovan koordinace";
        }
    }
}



#------------------------------------------------------------------------------
# Pevrt zaven sloench pedloek, aby ml parser vbec anci.
#------------------------------------------------------------------------------
sub transformovat_slozene_predlozky
{
    my $i;
    my @n_deti;
    # Prochzet seznamem uzl. Najdeme-li pedloku, na kter nic nevis,
    # podvme se na jej dc uzel. Pokud je to podstatn jmno v pd
    # kompatibilnm s pedlokou, pouze ho s pedlokou prohodme. Pokud
    # je to taky pedloka, najdeme mezi jejmi dtmi jet podstatn jmno,
    # z nj a z osiel pedloky slome pedlokovou frzi a to cel vsuneme
    # mezi druhou pedloku a jej dc uzel.
    for($i = 0; $i<=$#struktura; $i++)
    {
        $n_deti[$i] = 0;
    }
    for($i = 0; $i<=$#struktura; $i++)
    {
        $n_deti[$struktura[$i]]++;
    }
    for($i = 0; $i<=$#struktura; $i++)
    {
        if($znacky[$i]=~m/^R(\d)/ && $n_deti==0)
        {
            my $pad = $1;
            # Prvn monost: nad pedlokou uzel, kter pat pod n.
            if($znacky[$struktura[$i]]=~m/^N$pad/)
            {
                my $novy_rodic = $struktura[$struktura[$i]];
                $struktura[$struktura[$i]] = $i;
                $struktura[$i] = $novy_rodic;
            }
            # Druh monost: uzel, kter pat nad pedloku, vis vedle.
            elsif($znacky[$struktura[$i]]=~m/^R/)
            {
                my $novy_rodic = $struktura[$struktura[$i]];
                my $mezistupen = $i;
                my $j;
                for($j = 0; $j<=$#struktura; $j++)
                {
                    if($struktura[$j]==$struktura[$i])
                    {
                        $mezistupen = $j;
                        last;
                    }
                }
                $struktura[$struktura[$i]] = $mezistupen;
                $struktura[$mezistupen] = $i;
                $struktura[$i] = $novy_rodic;
            }
        }
    }
}



#------------------------------------------------------------------------------
# Vrt aktuln as jako etzec s polokami oddlenmi dvojtekou. Dlka
# etzce je vdy stejn (8 znak), co lze vyut pi sloupcovm formtovn.
#------------------------------------------------------------------------------
sub cas
{
    my($h, $m, $s);
    ($s, $m, $h) = localtime(time());
    return sprintf("%02d:%02d:%02d", $h, $m, $s);
}



